$( function() {
	
	
	$.widget("custom.myWidget",{
		options:{
			delay:0,
			red:255,
			green:0,
			blue:0,
			
			change:null,
			radom:null,
			myEvent:null,
		}
		,
		_create: function() {
			this.element.children('tr').addClass("my-widget-class");
			
			this.button = $("<button>",{
				text:"Select",
				'class':"my-widget-button"
			}).appendTo(this.element.children('tr'));
			
			this._on(this.button,{
				click:"random"
			});
			
			this._refresh();
		},
		_refresh : function(elem = null, colors = null) {
			if(!colors && !elem) {
				this.element.children('tr').css("background-color", 'rgb(' +  
					this.options.red +"," +
		          	this.options.green + "," +
		          	this.options.blue + ")"
	          	);
			}
			else {
				elem.css( "background-color", "rgb(" +
		         colors.red +"," +
		         colors.green + "," +
		         colors.blue + ")"
		        );
			}
			
			this._trigger('change');
		}
		,
		random : function(event) {
			var colors = {
				red : Math.floor(Math.random()*256),
				green: Math.floor(Math.random()*256),
				blue : Math.floor(Math.random()*256),
			}
			$(event.target).closest('tr').addClass('selected');
			this._refresh($(event.target).closest('tr'),colors);
			this._trigger('change');
		}
		,
		getIds : function() {
			var str = [];
			
			this.element.children('tr').each(function(ind, item) {
				if($(item).hasClass('selected')) {
					str.push($(item).attr('id'));
				}
			});
			
			return  str;
		}
		,
		_setOptions : function() {
			
			this._superApply(arguments);
			this._delay(this._refresh,  this.options.delay);
		}
		,
		_setOption : function (key, value) {
			if(value < 0 || value > 255) {
				return;
			}
			this._super(key, value);
		}
		
	});
	
	$('table tbody').myWidget({
		delay:1000
	});
	
	$('h2').click(function() {
		//console.log($('table tbody').myWidget('getIds'));
		
		$( "table tbody" ).myWidget('option','red',150);
    	$( "table tbody" ).myWidget('option','green',40);
    	$( "table tbody" ).myWidget('option','blue',150);
		
	});
	
});


